{ Este exemplo demonstra como fazer uma figura geomtrica ficar
  passeando pela tela do micro. Isto pode ser usado como material
  didtico para iniciantes em programao. Pode tambm ser
  aprimorado para ser usado como proteo de tela.

  Autor....: Daniel Pereira Guimares
  E-mail...: tecnobyte@ulbrajp.com.br
  Home-Page: www.ulbrajp.com.br/~tecnobyte
}

unit uBola;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    ParaDireita, ParaBaixo: boolean;
    P: TPoint;
    procedure ApagarBola;
    procedure DesenharBola;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  Diametro = 30;
  Salto = 5;
  TempoMax = 500;

procedure TForm1.FormCreate(Sender: TObject);
begin
  { Define a posio e os sentidos iniciais do movimento }
  P.x := 0;
  P.y := 0;
  ParaDireita := true;
  ParaBaixo := true;

  { Faz o formulrio cobrir toda tela, na cor preta.
    Isto faz este programa ficar semelhante a uma proteo de tela. }
  BorderStyle := bsNone;
  Left := 0;
  Top := 0;
  Width := Screen.Width;
  Height := Screen.Height;
  Color := clBlack;
end;

procedure TForm1.ApagarBola;
begin
  { Para apagar a bola, apenas a desenhamos novamente usando
    a cor do formulrio como cor da linha e do preenchimento. }
  Canvas.Pen.Color := Color;
  Canvas.Brush.Color := Color;
  Canvas.Ellipse(P.x, P.y, P.x + Diametro, P.y + Diametro);
end;

procedure TForm1.DesenharBola;
begin
  { A bola  desenhada com linha preta e preenchimento branco }
  Canvas.Pen.Color := clBlack;
  Canvas.Brush.Color := clWhite;
  Canvas.Ellipse(P.x, P.y, P.x + Diametro, P.y + Diametro);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  { Toda vez que o formulrio for re-pintado (evento OnPaint),
    re-desenhamos a bola. }
  DesenharBola;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  { Apaga a bola atual }
  ApagarBola;

  { Se estiver indo para direita... }
  if ParaDireita then begin
    { Se ainda pode dar mais um salto para direita
      sem sair do limite  direita do formulrio... }
    if P.x + Salto + Diametro <= ClientWidth then
      Inc(P.x, Salto)
    else begin
      { Se ainda no chegou ao limite mximo
         direita do formulrio... }
      if P.x + Diametro < ClientWidth then
        P.x := ClientWidth - Diametro
      else begin
        { Inverte o sentido horizontal.
          Agora vai andar para esquerda. }
        ParaDireita := false;
        Dec(P.x, Salto);
      end;
    end;
  end else begin { Est andando para esquerda. }
    { Se ainda pode dar mais um salto para esquerda
      sem sair do limite  esquerda do formulrio... }
    if P.x - Salto >= 0 then
      Dec(P.x, Salto)
    else begin
      { Se ainda no chegou ao limite mnimo  esquerda
        do formulrio... }
      if P.x > 0 then
        P.x := 0
      else begin
        { Muda o sentido horizontal.
          Agora vai andar para direita. }
        ParaDireita := true;
        Inc(P.x, Salto);
      end;
    end;
  end;

  { Se estiver descendo... }
  if ParaBaixo then begin
    { Se ainda pode dar mais um salto para baixo
      sem sair do limite inferior do formulrio... }
    if P.y + Salto + Diametro <= ClientHeight then
      Inc(P.y, Salto)
    else begin
      { Se ainda no chegou no limite mximo
        inferior do formulrio... }
      if P.y + Diametro < ClientHeight then
        P.y := ClientHeight - Diametro
      else begin
        { Muda o sentido vertical.
          Agora vai andar para cima. }
        ParaBaixo := false;
        Dec(P.y, Salto);
      end;
    end;
  end else begin { Est andando para cima. }
    { Se ainda pode dar mais um salto para cima
      sem sair do limite superior do formulrio... }
    if P.y - Salto >= 0 then
      Dec(P.y, Salto)
    else begin
      { Se ainda no atingiu o limite superior do formulrio... }
      if P.y > 0 then
        P.y := 0
      else begin
        { Muda o sentido vertical.
          Agora vai andar para baixo. }
        ParaBaixo := true;
        Inc(P.y, Salto);
      end;
    end;
  end;

  { Desenha a nova bola }
  DesenharBola;
end;

procedure TForm1.FormClick(Sender: TObject);
begin
  { Se der um click, fecha. }
  Close;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  { Se pressionar qualquer tecla, fecha. }
  Close;
end;

end.
